using System.Data;
using System.Drawing;
using System.IO;
using System.Reflection;


namespace GrapeCity.Documents.Excel.Examples.Templates.TemplatePagination
{
    class Program
    {
        static void Main(string[] args)
        {
			//create a new workbook
			var workbook = new GrapeCity.Documents.Excel.Workbook();

			// Load template file from resource
			var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template.xlsx");						//All settings
			//var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template - PaginationMode.xlsx");	//respective setting
			//var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template-RepeatOutput.xlsx");		//respective setting  
			//var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template-KeepTogether.xlsx");		//respective setting
			//var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template-AttachTo.xlsx");			//respective setting
			//var templateFile = GetResourceStream("xlsx\\ProductCatalog-Template-RepeatGroup.xlsx");		//respective setting



			workbook.Open(templateFile);

			#region Data
			
			DataTable data = new DataTable();
			data.Columns.Add("Ref", typeof(string));
			data.Columns.Add("Category", typeof(string));
			data.Columns.Add("Title", typeof(string));
			data.Columns.Add("Price", typeof(int));
			data.Columns.Add("Tags", typeof(string));
			data.Columns.Add("Description", typeof(string));
			data.Columns.Add("Image", typeof(string));

			data.Rows.Add("B4032400", "Rings", "Love ring, 3 diamonds", 3500, "yellow gold, diamonds", "Love ring, 18K yellow gold, set with 3 brilliant-cut diamonds totaling 0.22 carats. Width: 5.5mm.", "https://www.cartier.com/content/dam/rcq/car/58/47/16/584716.png");
			data.Rows.Add("B4087500", "Rings", "Love ring, 3 diamonds", 3500, "pink gold, diamonds", "Love ring, 18K rose gold, set with 3 brilliant-cut diamonds totaling 0.22 carats. Width: 5.5mm.", "https://www.cartier.com/content/dam/rcq/car/58/39/70/583970.png");
			data.Rows.Add("B4056100", "Rings", "Love wedding band, 1 diamond", 2020, "yellow gold, diamond", "Love wedding band, 18K yellow gold, set with 1 brilliant-cut diamonds totaling 02 carats. Width: 4mm.", "https://www.cartier.com/content/dam/rcq/car/63/23/97/632397.png");
			data.Rows.Add("B4050700", "Rings", "Love wedding band, 1 diamond", 2020, "pink gold, diamond", "Love wedding band, 18K rose gold, set with 1 brilliant-cut diamonds totaling 02 carats. Width: 4mm.", "https://www.cartier.com/content/dam/rcq/car/59/04/56/590456.png");
			data.Rows.Add("B4056200", "Rings", "Love wedding band, 8 diamonds", 3550, "yellow gold, diamonds", "Love wedding band, 18K yellow gold, set with 8 brilliant-cut diamonds totaling 0.19 carats. Width: 4mm.", "https://www.cartier.com/content/dam/rcq/car/63/24/04/632404.png");
			data.Rows.Add("B4050800", "Rings", "Love wedding band, 8 diamonds", 3550, "pink gold, diamonds", "Love wedding band, 18K rose gold, set with 8 brilliant-cut diamonds totaling 0.19 carats. Width: 4mm.", "https://www.cartier.com/content/dam/rcq/car/63/24/01/632401.png");
			data.Rows.Add("B4218100", "Rings", "Love ring, SM", 4500, "pink gold, diamonds", "Love ring, small model, 18K pink gold, set with 72 brilliant-cut diamonds totaling 0.19 carats. Width: 2.6mm.", "https://www.cartier.com/content/dam/rcq/car/10/57/33/2/1057332.png");
			data.Rows.Add("B4218200", "Rings", "Love ring, SM", 4800, "white gold, diamonds", "Love ring, small model, 18K white gold, set with 72 brilliant-cut diamonds totaling 0.19 carats. Width: 2.6mm.", "https://www.cartier.com/content/dam/rcq/car/10/57/33/4/1057334.png");
			data.Rows.Add("B4083400", "Rings", "Love wedding band, diamond-paved", 7100, "white gold, diamonds", "Love wedding band, 18K white gold, set with 88 brilliant-cut diamond totaling 0.31 carats. 4mm to 5mm width following sizes.", "https://www.cartier.com/content/dam/rcq/car/63/24/06/632406.png");
			data.Rows.Add("B6064516", "Bracelets", "Panthre de Cartier bracelet", 8750, "yellow gold, tsavorite garnets, diamonds", "Panthre de Cartier bracelet, 18K yellow gold, black lacquer, set with one tsavorite garnet and 19 brilliant-cut diamonds totaling 07 carats.", "https://www.cartier.com/content/dam/rcq/car/16/48/34/8/1648348.png");
			data.Rows.Add("N6039117", "Bracelets", "Love bracelet, 12 diamonds", 19800, "pink gold, white gold, diamonds", "Love bracelet, 18K rose gold, 18K white gold, set with 12 brilliant-cut diamonds totaling 0.78 carats. Sold with a screwdriver. Rose gold width 6.1mm.", "https://www.cartier.com/content/dam/rcq/car/59/17/31/591731.png");
			data.Rows.Add("B6047217", "Bracelets", "Love bracelet, small model, 6 diamonds", 6000, "yellow gold, diamonds", "Love bracelet, small model, 18K yellow gold, set with 6 diamonds totaling 0.15 carats.", "https://www.cartier.com/content/dam/rcq/car/16/41/57/5/1641575.png");
			data.Rows.Add("B6064617", "Bracelets", "Love bracelet", 7600, "yellow gold", "Love bracelet, 18K yellow gold.", "https://www.cartier.com/content/dam/rcq/car/19/55/29/9/1955299.png");
			data.Rows.Add("B6036517", "Bracelets", "Love bracelet", 7750, "pink gold, sapphires, garnets, amethysts", "# LOVE# bracelet, 18K rose gold, set with 2 rose sapphires, 2 yellow sapphires, 2 green garnets, 2 orange garnets and 2 amethysts. Sold with a screwdriver. Width: 6.1mm.", "https://www.cartier.com/content/dam/rcq/car/58/77/58/587758.png");
			data.Rows.Add("B6027000", "Bracelets", "Love bracelet", 1630, "pink gold", "Love bracelet, 18K pink gold. Width: 2.55 mm. Inner diameter: 9.7 mm.", "https://www.cartier.com/content/dam/rcq/car/90/26/03/902603.png");
			data.Rows.Add("B7009100", "Necklaces", "Santos de Cartier necklace", 8000, "white gold", "Santos-Dumont chain necklace, 18K white gold.", "https://www.cartier.com/content/dam/rcq/car/13/65/85/6/1365856.png");
			data.Rows.Add("B7060900", "Necklaces", "Chain necklace", 1250, "white gold, yellow gold, pink gold", "Chain necklace, 18K white gold, 18K pink gold, 18K yellow gold.", "https://www.cartier.com/content/dam/rcq/car/13/65/87/0/1365870.png");
			data.Rows.Add("B7224736", "Necklaces", "Chain necklace", 1250, "yellow gold", "Chain necklace, 18K yellow gold.", "https://www.cartier.com/content/dam/rcq/car/17/46/76/6/1746766.png");
			data.Rows.Add("N7424155", "Necklaces", "Essential Lines necklace", 53000, "white gold, diamonds", "Essential Lines necklace, 18K white gold, set with 135 brilliant-cut diamonds totaling 7.41 carats.", "https://www.cartier.com/content/dam/rcq/car/96/78/50/967850.png");
			data.Rows.Add("H7000130", "Necklaces", "Reflection de Cartier necklace", 370000, "white gold, diamonds", "Reflection de Cartier necklace, 18K white gold, set with 264 brilliant-cut diamonds totaling 11.40 carats, and with 132 baguette-cut diamonds totaling 14.25 carats.", "https://www.cartier.com/content/dam/rcq/car/13/61/50/2/1361502.png");
			data.Rows.Add("B7224513", "Necklaces", "Juste un Clou necklace", 3850, "pink gold, diamonds", "Juste un Clou necklace, 18K rose gold, set with 14 brilliant-cut diamonds totaling 0.12 carats. Width: 2.2mm. Inner diameter 14.2mm. Adjustable chain length 39-41mm.", "https://www.cartier.com/content/dam/rcq/car/13/61/40/0/1361400.png");
			data.Rows.Add("B7224511", "Necklaces", "Juste un Clou necklace", 6350, "yellow gold, diamonds", "Juste un Clou necklace, 18K yellow gold, set with 36 brilliant-cut diamonds totaling 0.38 carat.", "https://www.cartier.com/content/dam/rcq/car/13/65/77/8/1365778.png");
			data.Rows.Add("N7424322", "Necklaces", "Etincelle de Cartier necklace", 12800, "pink gold, diamonds", "tincelle de Cartier necklace, 18K pink gold, set with 97 brilliant-cut pav diamonds totaling 1.16 carats.", "https://www.cartier.com/content/dam/rcq/car/18/11/98/1/1811981.png");
			data.Rows.Add("N3108600", "Necklaces", "Etincelle de Cartier necklace", 16300, "white gold, diamonds", "Etincelle de Cartier necklace, 18K white gold, set with 140 brilliant-cut diamonds totaling 1.15 carats.", "https://www.cartier.com/content/dam/rcq/car/13/61/55/9/1361559.png");
			data.Rows.Add("N7424151", "Necklaces", "Essential Lines necklace", 49200, "pink gold, diamonds", "Essential Lines necklace, 18K pink gold, set with 135 brilliant-cut diamonds totaling 7.41 carats.", "https://www.cartier.com/content/dam/rcq/car/13/61/59/7/1361597.png");
			data.Rows.Add("B7224515", "Necklaces", "Diamants Lgers necklace XS",950,"white gold, diamond","Diamants Lgers necklace, 18K white gold, set with a brilliant - cut diamond of 04 carats.","https://www.cartier.com/content/dam/rcq/car/13/61/40/3/1361403.png");
			data.Rows.Add("B7224573", "Necklaces", "Etincelle de Cartier necklace", 3750, "white gold, diamonds", "Etincelle de Cartier necklace, 18K white gold, set with 6 brilliant-cut diamonds totaling 0.26 carats.", "https://www.cartier.com/content/dam/rcq/car/14/37/85/9/1437859.png");
			data.Rows.Add("N7424261", "Necklaces", "Essential Lines necklace", 39300, "white gold, sapphires", "Essential Lines necklace, 18K white gold, set with 135 brilliant-cut sapphires.", "https://www.cartier.com/content/dam/rcq/car/16/71/09/0/1671090.png");

			#endregion


			// Set PaginationMode to true.
			workbook.Names.Add("TemplateOptions.PaginationMode", "true");

			// Add data source
			workbook.AddDataSource("ds", data);

			// Invoke to process the template
			workbook.ProcessTemplate();
		        
			// Save to an excel file
			workbook.Save("ProductCatalog.xlsx");

        }

		static Stream GetResourceStream(string resourcePath)
        {
            string resource = "ProductCatalog.Resource." + resourcePath.Replace("\\", ".");
            var assembly = typeof(Program).GetTypeInfo().Assembly;
            return assembly.GetManifestResourceStream(resource);
        }

    }
}